var P=Object.defineProperty;var T=(n,o,d)=>o in n?P(n,o,{enumerable:!0,configurable:!0,writable:!0,value:d}):n[o]=d;var p=(n,o,d)=>(T(n,typeof o!="symbol"?o+"":o,d),d);(function(n,o){typeof exports=="object"&&typeof module!="undefined"?o(exports,require("ajv")):typeof define=="function"&&define.amd?define(["exports","ajv"],o):(n=typeof globalThis!="undefined"?globalThis:n||self,o(n.Temperament={},n.ajv))})(this,function(n,o){"use strict";function d(i){return i&&typeof i=="object"&&"default"in i?i:{default:i}}var g=d(o),y={title:"Temperament",description:"A complete description of a musical temperament with additional metadata.",type:"object",required:["name","octaveBaseName","referencePitch","referenceName","referenceOctave","notes"],properties:{name:{description:"The name of the temperament.",type:"string"},description:{description:"A description of the temperament.",type:"string"},source:{description:"The source from which the temperament data was obtained.",type:"string"},octaveBaseName:{description:"The name of the base note of the octave.",type:"string"},referencePitch:{description:"The frequency (in Hz) of the reference pitch.",type:"number",exclusiveMinimum:0},referenceName:{description:"The note name of the reference pitch.",type:"string"},referenceOctave:{description:"The octave number of the reference pitch.",type:"integer"},notes:{description:"A mapping of note names to a description of each note.",type:"object",minProperties:1,additionalProperties:{description:"A description of the note, as an offset from another note.",type:"array",minItems:2,maxItems:2,items:[{description:"The base note from which to offset.",type:"string"},{description:"The offset (in cents) from the base note.",type:"number"}]}}}};const O=new g.default,_=O.compile(y),c=1200;function l(i,e,t){const r=i.get(e);if(r!==void 0&&(r-t)%c!=0)throw new Error(`Conflicting definition for '${e}' found`);i.set(e,t)}function w(i){const e=i.notes,t=new Map([[i.referenceName,0]]),r=[[i.referenceName,0]];for(;r.length!==0;){const[a,v]=r[0];if(Object.prototype.hasOwnProperty.call(e,a)){const[s,u]=e[a],m=v-u;s!==a&&!t.has(s)&&r.push([s,m]),l(t,s,m)}Object.keys(e).filter(s=>e[s][0]===a).forEach(s=>{const u=e[s][1],m=v+u;s!==a&&!t.has(s)&&r.push([s,m]),l(t,s,m)}),r.shift()}Object.keys(e).forEach(a=>{if(!t.has(a))throw new Error(`Not able to determine the pitch of '${a}'`)});const h=t.get(i.octaveBaseName);if(h===void 0)throw new Error("Octave base not defined as a note");const f=h>0?h%c-c:h%c;return t.set(i.octaveBaseName,f),t.forEach((a,v)=>{let s=a-f;s%=c,s<0&&(s+=c),t.set(v,f+s)}),t}class b{constructor(e){p(this,"name");p(this,"description");p(this,"source");p(this,"_octaveBaseName");p(this,"_referenceName");p(this,"_referenceOctave");p(this,"_referencePitch");p(this,"_noteNames");p(this,"_offsets");if(!_(e))throw new TypeError(`Incorrect temperament format: ${O.errorsText(_.errors)}`);this.name=e.name,this.description=e.description,this.source=e.source,this._octaveBaseName=e.octaveBaseName,this._referenceName=e.referenceName,this._referenceOctave=e.referenceOctave,this._referencePitch=e.referencePitch,this._offsets=w(e),this._noteNames=[...this._offsets.entries()].sort((t,r)=>t[1]-r[1]).map(t=>t[0])}get noteNames(){return[...this._noteNames]}get octaveBaseName(){return this._octaveBaseName}get referenceName(){return this._referenceName}get referenceOctave(){return this._referenceOctave}get referencePitch(){return this._referencePitch}set referencePitch(e){if(e<=0)throw new Error("Pitch must be positive");this._referencePitch=e}getNoteNameFromPitch(e){if(e<=0)throw new Error("Pitch must be positive");const t=this.getOffset(this._octaveBaseName,this._referenceOctave);let r=Math.log2(e/this._referencePitch)*c;r=(r-t)%c+t,r<t&&(r+=c);let h=0,f=this._noteNames.length;for(;f-h>1;){const m=Math.trunc((f+h)/2),N=this.getOffset(this._noteNames[m],this._referenceOctave);if(r>N)h=m;else if(r<N)f=m;else return[this._noteNames[m],0]}const a=this._noteNames[h],v=r-this.getOffset(a,this._referenceOctave);let s,u;return f===this._noteNames.length?(s=this._noteNames[0],u=r-this.getOffset(s,this._referenceOctave)-c):(s=this._noteNames[f],u=r-this.getOffset(s,this._referenceOctave)),Math.abs(v)<Math.abs(u)?[a,v]:[s,u]}getOctaveRange(e){if(e<0)throw new Error("Radius must not be negative");const t=this._referenceOctave-e,r=this._referenceOctave+e,h=[];for(let f=t;f<=r;f++)h.push(f);return h}getOffset(e,t){const r=this._offsets.get(e);if(r===void 0)throw new Error(`Note '${e}' is not defined`);return r+(t-this._referenceOctave)*c}getPitch(e,t){return this._referencePitch*2**(this.getOffset(e,t)/c)}toJSON(){return{name:this.name,description:this.description,source:this.source,octaveBaseName:this.octaveBaseName,referencePitch:this.referencePitch,referenceName:this.referenceName,referenceOctave:this.referenceOctave,notes:Object.fromEntries([...this._offsets.entries()].map(([e,t])=>[e,[this.referenceName,t]]))}}}n.OCTAVE_SIZE=c,n.Temperament=b,Object.defineProperty(n,"__esModule",{value:!0}),n[Symbol.toStringTag]="Module"});
//# sourceMappingURL=temperament.umd.cjs.map
